<?php
/*
 * Copyright (C) TIPS4DESIGN SRL - All Rights Reserved
 * Unauthorized copying of this file or any parts of it, via any medium is strictly prohibited
 * Only a valid UXWizz license holder should have access to this file
 * Proprietary and confidential
 * Written by Cristian Buleandră <cristian@uxwizz.com>, Sat 02 March 2024
 */

$AI_QUERY_INPUT = $_POST['query'];
require_once __DIR__ . '/../../login.php';
require_once __DIR__ . '/../../permissions.php';
try { checkPermission('CHAT_WITH_AI'); } catch(Exception $e) { die($e->getMessage());}


// Query matches last query returned by the AI
$savedQuery = $_SESSION['UXW_CHAT_LAST_RESPONSE'];
$needleForRegex = preg_quote($AI_QUERY_INPUT, '/');
if (!preg_match('/"message":\s*"' . $needleForRegex . '"/', $savedQuery)) {
    die("Security Check Error: Submitted query doesn't match cached AI response. Not executing it.");
}

// Query doesn't mutate data
$banned_queries = '/\b(update|delete|drop)\b/i';
if (preg_match($banned_queries, $AI_QUERY_INPUT)) {
    die('Security Check Error: Submitted query mutates or deletes data. Not executing it.');
}

try {
    $stmt = $db->query($AI_QUERY_INPUT);
    // TODO: How do we know if we have to return a number, array or something else
    echo json_encode($stmt->fetchAll(PDO::FETCH_ASSOC), JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES | JSON_NUMERIC_CHECK);
} catch (PDOException $e) {
    echo 'Query execution failed: ' . $e->getMessage();
}
?>