<?php

/*
 * Copyright (C) TIPS4DESIGN SRL - All Rights Reserved
 * Unauthorized copying of this file or any parts of it, via any medium is strictly prohibited
 * Only a valid UXWizz license holder should have access to this file
 * Proprietary and confidential
 * Written by Cristian Buleandră <cristian@uxwizz.com>, Mon 04 March 2024
 */


require_once __DIR__ . '/../../login.php';
require_once __DIR__ . '/availableModels.php';

function getAIModel() {
    global $db, $availableModels;
    $model = $db->query("SELECT value FROM `ust_meta` WHERE `key`='CHATBOT_SETTING_CHATGPT_MODEL'")->fetch(PDO::FETCH_COLUMN);
    if (!$model) return $availableModels[0];
    return htmlentities($model);
}

// POST: /getAiModel
if(isset($_REQUEST['is_api_request'])) {
    require_once __DIR__ . '/../../permissions.php';
    try { checkPermission('CHAT_WITH_AI'); } catch(Exception $e) { die($e->getMessage());}
    echo getAIModel();
}